import { Injectable } from '@nestjs/common';
import { BaseUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-update-status.manager';
import { UserEntity } from '../../entities/user.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { UserModel } from '../../../data/models/user.model';
import { UserChangeStatusEvent } from '../../entities/event/user-change-status.event';

@Injectable()
export class InactiveUserManager extends BaseUpdateStatusManager<UserEntity> {
  getResult(): string {
    return `Success inactive data ${this.result.name}`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return UserModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: UserChangeStatusEvent,
        data: this.result,
      },
    ];
  }
}
